Index: chan_iax2.c
===================================================================
--- chan_iax2.c	(revision 41227)
+++ chan_iax2.c	(working copy)
@@ -158,6 +158,7 @@
 static int authdebug = 1;
 static int autokill = 0;
 static int iaxcompat = 0;
+static int srvlookup = 0;
 
 static int iaxdefaultdpcache=10 * 60;	/* Cache dialplan entries for 10 minutes by default */
 
@@ -2594,8 +2595,6 @@
 
 static int create_addr(const char *peername, struct sockaddr_in *sin, struct create_addr_info *cai)
 {
-	struct ast_hostent ahp;
-	struct hostent *hp;
 	struct iax2_peer *peer;
 
 	ast_clear_flag(cai, IAX_SENDANI | IAX_TRUNK);
@@ -2606,17 +2605,14 @@
 	if (!(peer = find_peer(peername, 1))) {
 		cai->found = 0;
 
-		hp = ast_gethostbyname(peername, &ahp);
-		if (hp) {
-			memcpy(&sin->sin_addr, hp->h_addr, sizeof(sin->sin_addr));
-			sin->sin_port = htons(IAX_DEFAULT_PORTNO);
-			/* use global iax prefs for unknown peer/user */
-			ast_codec_pref_convert(&prefs, cai->prefs, sizeof(cai->prefs), 1);
-			return 0;
-		} else {
-			ast_log(LOG_WARNING, "No such host: %s\n", peername);
+		sin->sin_port = htons(IAX_DEFAULT_PORTNO);
+		if (ast_get_ip_or_srv(sin, peername, srvlookup ? "_iax._udp" : NULL)<0) {
+		 	ast_log(LOG_WARNING, "No such host: %s\n", peername);
 			return -1;
 		}
+		/* use global iax prefs for unknown peer/user */
+		ast_codec_pref_convert(&prefs, cai->prefs, sizeof(cai->prefs), 1);
+		return 0;
 	}
 
 	cai->found = 1;
@@ -8774,6 +8770,7 @@
 			ast_log(LOG_WARNING, "Invalid tos value, see doc/ip-tos.txt for more information.\n");
 	}
 	while(v) {
+	  ast_log(LOG_VERBOSE, "parsing name [%s] val [%s]\n", v->name, v->value);
 		if (!strcasecmp(v->name, "bindport")){ 
 			if (reload)
 				ast_log(LOG_NOTICE, "Ignoring bindport on reload\n");
@@ -8928,6 +8925,8 @@
 			iax2_register(v->value, v->lineno);
 		} else if (!strcasecmp(v->name, "iaxcompat")) {
 			iaxcompat = ast_true(v->value);
+		} else if (!strcasecmp(v->name, "srvlookup")) {
+			srvlookup = ast_true(v->value);
 		} else if (!strcasecmp(v->name, "regcontext")) {
 			ast_copy_string(regcontext, v->value, sizeof(regcontext));
 			/* Create context if it doesn't exist already */
